using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using System.Diagnostics;

namespace MagGame
{
    public class HorizontalBar
    {
        private int m_CurrentValue;
        UWB_PrimitiveRectangle rect;
        UWB_PrimitiveRectangle rect2;
        
        UWB_PrimitiveCircle P1L1;
        UWB_PrimitiveCircle P1L2;
        UWB_PrimitiveCircle P1L3;
        
        UWB_PrimitiveCircle P2L1;
        UWB_PrimitiveCircle P2L2;
        UWB_PrimitiveCircle P2L3;

        UWB_BoundingBox m_BarBorder;
        Vector3 m_min;
        Vector3 m_max;

        public HorizontalBar()
        {
            m_CurrentValue = 50;
            rect = new UWB_PrimitiveRectangle();
            rect2 = new UWB_PrimitiveRectangle();
            m_BarBorder = new UWB_BoundingBox();
            m_min = new Vector3(0, 0, 0);

            P1L1 = new UWB_PrimitiveCircle();
            P1L2 = new UWB_PrimitiveCircle();
            P1L3 = new UWB_PrimitiveCircle();

            P2L1 = new UWB_PrimitiveCircle();
            P2L2 = new UWB_PrimitiveCircle();
            P2L3 = new UWB_PrimitiveCircle();
        }

        public void Initialize()
        {

            //Initialize the Sprite batch
            //mBatch = new SpriteBatch(MagGame.MyGraphics.GraphicsDevice);

            Vector3 corner1 = new Vector3(0, 0, 0);
            m_max = new Vector3(50, 10, 0);
            rect.SetCorners(m_min, m_max);
            rect.SetTextureFilename("redbar");
            rect.EnableBlending(true);
            rect.EnableTexturing(true);

            m_max = new Vector3(100, 10, 0);
            rect2.SetCorners(m_min, m_max);
            rect2.SetTextureFilename("bluebar");
            rect2.EnableBlending(true);
            rect2.EnableTexturing(true);

            corner1 = m_min;
            Vector3 corner2 = new Vector3(100, 10, 0);
            m_BarBorder.SetCorners(corner1, corner2);

            Vector3 center = new Vector3(2.5f, 5f, 0);
            float radius = 1.5f;

            P1L1.setCenter(center);
            P1L1.setRadius(radius);
            P1L1.SetTextureFilename("chinared");
            P1L1.EnableBlending(true);
            P1L1.EnableTexturing(true);

            center = new Vector3(5, 5, 0);

            P1L2.setCenter(center);
            P1L2.setRadius(radius);
            P1L2.SetTextureFilename("chinared");
            P1L2.EnableBlending(true);
            P1L2.EnableTexturing(true);

            center = new Vector3(7.5f, 5, 0);

            P1L3.setCenter(center);
            P1L3.setRadius(radius);
            P1L3.SetTextureFilename("chinared");
            P1L3.EnableBlending(true);
            P1L3.EnableTexturing(true);

            center = new Vector3(97.5f, 5, 0);

            P2L1.setCenter(center);
            P2L1.setRadius(radius);
            P2L1.SetTextureFilename("chinared");
            P2L1.EnableBlending(true);
            P2L1.EnableTexturing(true);

            center = new Vector3(95f, 5, 0);

            P2L2.setCenter(center);
            P2L2.setRadius(radius);
            P2L2.SetTextureFilename("chinared");
            P2L2.EnableBlending(true);
            P2L2.EnableTexturing(true);

            center = new Vector3(92.5f, 5, 0);

            P2L3.setCenter(center);
            P2L3.setRadius(radius);
            P2L3.SetTextureFilename("chinared");
            P2L3.EnableBlending(true);
            P2L3.EnableTexturing(true);
        }

        public int CurrentValue
        {
            get
            {
                return m_CurrentValue;
            }
            set
            {
                m_CurrentValue = value;
                m_CurrentValue = (int)MathHelper.Clamp(m_CurrentValue, 0, 100);
                m_max.X = m_CurrentValue;
                rect.SetCorners(m_min, m_max);
            }
        }

        public UWB_BoundingBox GetBarBorder()
        {
            return m_BarBorder;
        }

        public void Draw(eLevelofDetail lod, UWB_DrawHelper drawHelper)
        {        
            drawHelper.resetAttributes();
            drawHelper.setFillMode(eFillMode.fmWireframe);
            drawHelper.setShadeMode(eShadeMode.smGouraud);
            drawHelper.setColor1(Color.Blue);
            drawHelper.setColor2(Color.Blue);
            rect2.draw(lod, drawHelper);
            rect.draw(lod, drawHelper);

            switch (Program.getGame().GetP1Stat())
            {
                case 1:
                    P1L1.draw(lod, drawHelper);
                    break;
                case 2:
                    {
                        P1L1.draw(lod, drawHelper);
                        P1L2.draw(lod, drawHelper);
                        break;
                    }
                case 3:
                    {
                        P1L1.draw(lod, drawHelper);
                        P1L2.draw(lod, drawHelper);
                        P1L3.draw(lod, drawHelper);
                        break;
                    }
            }

            switch (Program.getGame().GetP2Stat())
            {
                case 1:
                    P2L1.draw(lod, drawHelper);
                    break;
                case 2:
                    {
                        P2L1.draw(lod, drawHelper);
                        P2L2.draw(lod, drawHelper);
                        break;
                    }
                case 3:
                    {
                        P2L1.draw(lod, drawHelper);
                        P2L2.draw(lod, drawHelper);
                        P2L3.draw(lod, drawHelper);
                        break;
                    }
            }
        }

    }
}