using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;

namespace TechDemo
{
    class ControllerHandler
    {
        private GamePadState[] prevGamePadsState = new GamePadState[4];
        private GamePadState[] gamePadsState = new GamePadState[4];

        public ControllerHandler()
        {
            prevGamePadsState[0] = GamePad.GetState(PlayerIndex.One);
            prevGamePadsState[1] = GamePad.GetState(PlayerIndex.Two);

        }

        public void Update(ref Hero p1hero, ref Hero p2hero)
        {   // we need previous and current to detect when the button was just pressed
            // set our previous state to our new state
            prevGamePadsState[0] = gamePadsState[0];
            prevGamePadsState[1] = gamePadsState[1];

            // get our new state
            gamePadsState[0] = GamePad.GetState(PlayerIndex.One);
            gamePadsState[1] = GamePad.GetState(PlayerIndex.Two);



            // ** first check player one input

            // if player 1 is pressing A
            if (gamePadsState[0].Buttons.A == ButtonState.Pressed &&
                            prevGamePadsState[0].Buttons.A == ButtonState.Released)
            {
                //p1hero.SetSpeed(new Vector3(1f, 0, 0));
                //  p1root.setXformInfo(xf);
            }
            // if detraction magnet is pushed conusme fuel and give hero the magnet power
            if (gamePadsState[0].Triggers.Right > 0)
            {
                // only the trigger pushed down the most used, and the hero must have some fuel
                if (p1hero.hasFuel() && gamePadsState[0].Triggers.Right > gamePadsState[0].Triggers.Left)
                {
                    p1hero.changeConsumption(gamePadsState[0].Triggers.Right);
                    // TODO: give the hero detraction magnet power
                }
            }
            
            // velocity is the y axis of left controller
            p1hero.SetSpeed(prevGamePadsState[0].ThumbSticks.Left.Y*-3f);
            p1hero.setRotation(prevGamePadsState[0].ThumbSticks.Right.X*-3f);
            GamePad.SetVibration(PlayerIndex.One, prevGamePadsState[0].Triggers.Left,
                prevGamePadsState[0].Triggers.Right);

            // ** check for player two input
            // if player 2 is pressing A
            if (gamePadsState[1].Buttons.A == ButtonState.Pressed &&
                            prevGamePadsState[1].Buttons.A == ButtonState.Released)
            {
                //p1hero.SetSpeed(new Vector3(1f, 0, 0));
                //  p1root.setXformInfo(xf);
            }
            // velocity is the y axis of left controller
            p2hero.SetSpeed(prevGamePadsState[1].ThumbSticks.Left.Y * -3f);
            p2hero.setRotation(prevGamePadsState[1].ThumbSticks.Right.X * -3f);
            GamePad.SetVibration(PlayerIndex.Two, prevGamePadsState[1].Triggers.Left,
                prevGamePadsState[1].Triggers.Right);

        }


        public void checkInput(ref Hero p1hero) // InputHandler.ButtonType button)
        {
     
        }
    }
}
