using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace MagGame
{
    public class Hole : Obstacle
    {
        UWB_PrimitiveRectangle rect;
        UWB_XformInfo xf;

        public Hole(int num) : base()
        {
            rect = new UWB_PrimitiveRectangle();
            xf = new UWB_XformInfo();
            
            // Randomly create an obstacle of specified type
            // within 125 to 325 x and 16 to 116 x 
            m_type = Obstacle.eObstacleType.hole;
            myRand = new Random();
            m_size = (float)myRand.Next(25, 40); // /num; <- only making 1 hole for now..
            m_location = new Vector3();
            m_location.X = (float)myRand.Next(125, 325);
            m_location.Y = (float)myRand.Next(16, 116);

            Vector3 corner1 = new Vector3(m_location.X - m_size, m_location.Y - m_size, 0);
            Vector3 corner2 = new Vector3(m_location.X + m_size, m_location.Y + m_size, 0);

            rect.SetCorners(corner1, corner2);
            
            switch (num)
            {
                case 1:
                    rect.SetTextureFilename("hole");
                    break;
                case 2:
                    rect.SetTextureFilename("redspiral");
                    break;
                default:
                    rect.SetTextureFilename("hole");
                    break;
            }

            rect.EnableBlending(true);
            rect.EnableTexturing(true);
            myBound.Center = m_location;
            myBound.Radius = m_size;
            xf.SetPivot(m_location);
        }

        public override void Animate(float elapsedSeconds)
        {
            xf.SetRotationInRadians(xf.GetRotationInRadians() + (float)Math.Sin(1) * elapsedSeconds * 10);
        }

        public override void Draw(eLevelofDetail lod, UWB_DrawHelper drawHelper)
        {
            drawHelper.PushModelTransform();
            xf.SetUpModelStack(drawHelper);

            drawHelper.resetAttributes();
            drawHelper.setFillMode(eFillMode.fmWireframe);
            drawHelper.setShadeMode(eShadeMode.smGouraud);
            drawHelper.setColor1(Color.Blue);
            drawHelper.setColor2(Color.Blue);
            rect.draw(lod, drawHelper);
            
            drawHelper.PopModelTransform();
        }

        public override UWB_BoundingCircle getObjectBound()
        {
            return myBound;
        }
    }
}
