using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace MagGame
{
    public class Obstacle : WorldObject
    {
        public enum eObstacleType { hole, wall };
        protected UWB_Primitive obstacle;
        protected float m_size;
        protected eObstacleType m_type;
        protected Random myRand;
        protected Vector3 m_location = new Vector3();

        public Obstacle()
        {
            myRand = new Random();
            obstacle = new UWB_PrimitiveCircle();
        }

        public eObstacleType getType()
        {
            return m_type;
        }

        // DEBUG
        public void DrawBound(UWB_DrawHelper helper)
        {
            helper.resetAttributes();
            helper.setFillMode(eFillMode.fmWireframe);
            helper.setShadeMode(eShadeMode.smFlat);
            helper.setColor1(Color.Azure);
            myBound.Draw(helper);
        }

        public virtual void Draw(eLevelofDetail lod, UWB_DrawHelper helper)
        {
            helper.resetAttributes();
            helper.setFillMode(eFillMode.fmSolid);
            helper.setShadeMode(eShadeMode.smFlat);
            helper.setColor1(Color.Azure);
            obstacle.draw(lod, helper);
        }

        public bool isInObstacle(UWB_BoundingCircle other)
        {
            UWB_BoundingVolume pOther = (UWB_BoundingVolume)other;
            return myBound.Intersects(ref pOther);
        }

        public virtual void Animate(float elapsedSeconds)
        {
        }


    }
}
